# ApplicationApi

All URIs are relative to *http://localhost/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**genericPost**](ApplicationApi.md#genericPost) | **POST** /generic | Generic application deployment


<a name="genericPost"></a>
# **genericPost**
> Deployment genericPost(applicationName, networkType, components)

Generic application deployment

Deploy a generic application in a multi-cloud setup 

### Example
```java
// Import classes:
//import de.uulm.omi.cloudiator.catalogue.client.ApiException;
//import de.uulm.omi.cloudiator.catalogue.client.api.ApplicationApi;


ApplicationApi apiInstance = new ApplicationApi();
String applicationName = "applicationName_example"; // String | maps to the parent application description to identify its application components
String networkType = "networkType_example"; // String | specifies the network type for the generic application
java.util.List<Component> components = Arrays.asList(new Component()); // java.util.List<Component> | a list of application components
try {
    Deployment result = apiInstance.genericPost(applicationName, networkType, components);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ApplicationApi#genericPost");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **applicationName** | **String**| maps to the parent application description to identify its application components | [enum: MOLPRO]
 **networkType** | **String**| specifies the network type for the generic application | [enum: PRIVATE, PUBLIC]
 **components** | [**java.util.List&lt;Component&gt;**](Component.md)| a list of application components |

### Return type

[**Deployment**](Deployment.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

