# BigDataApi

All URIs are relative to *http://localhost/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**bigdataSparkPost**](BigDataApi.md#bigdataSparkPost) | **POST** /bigdata/spark | deploys an Apache Spark cluster
[**bigdataSparkSparkJobPost**](BigDataApi.md#bigdataSparkSparkJobPost) | **POST** /bigdata/spark/sparkJob | submit an Apache Spark job to a Spark Master


<a name="bigdataSparkPost"></a>
# **bigdataSparkPost**
> Deployment bigdataSparkPost(name, cluster)

deploys an Apache Spark cluster

Deploys a Spark cluster with 1 master and n workers in a multi-cloud environment or a Knime Spark cluster with a job server in front of the Master 

### Example
```java
// Import classes:
//import de.uulm.omi.cloudiator.catalogue.client.ApiException;
//import de.uulm.omi.cloudiator.catalogue.client.api.BigDataApi;


BigDataApi apiInstance = new BigDataApi();
String name = "name_example"; // String | the application  name, needs to map an existing application description
Cluster cluster = new Cluster(); // Cluster | the Spark cluster, including one master and n workers
try {
    Deployment result = apiInstance.bigdataSparkPost(name, cluster);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling BigDataApi#bigdataSparkPost");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **name** | **String**| the application  name, needs to map an existing application description | [enum: Spark, KnimeSpark]
 **cluster** | [**Cluster**](Cluster.md)| the Spark cluster, including one master and n workers |

### Return type

[**Deployment**](Deployment.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="bigdataSparkSparkJobPost"></a>
# **bigdataSparkSparkJobPost**
> java.util.List&lt;Deployment&gt; bigdataSparkSparkJobPost(job)

submit an Apache Spark job to a Spark Master

Submitting Spark jobs to an existing Apache Spark Cluster  

### Example
```java
// Import classes:
//import de.uulm.omi.cloudiator.catalogue.client.ApiException;
//import de.uulm.omi.cloudiator.catalogue.client.api.BigDataApi;


BigDataApi apiInstance = new BigDataApi();
SparkJob job = new SparkJob(); // SparkJob | the Spark job to submit
try {
    java.util.List<Deployment> result = apiInstance.bigdataSparkSparkJobPost(job);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling BigDataApi#bigdataSparkSparkJobPost");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **job** | [**SparkJob**](SparkJob.md)| the Spark job to submit |

### Return type

[**java.util.List&lt;Deployment&gt;**](Deployment.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

