# DatabaseApi

All URIs are relative to *http://localhost/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**databaseClusterPost**](DatabaseApi.md#databaseClusterPost) | **POST** /database/cluster | DDBMS cluster deployment
[**databaseCrossClusterPost**](DatabaseApi.md#databaseCrossClusterPost) | **POST** /database/crossCluster | DDBMS cluster deployment
[**databaseSinglePost**](DatabaseApi.md#databaseSinglePost) | **POST** /database/single | DDBMS cluster deployment


<a name="databaseClusterPost"></a>
# **databaseClusterPost**
> Deployment databaseClusterPost(networType, databaseComponents)

DDBMS cluster deployment

Deploy a database cluster in the multi-cloud 

### Example
```java
// Import classes:
//import de.uulm.omi.cloudiator.catalogue.client.ApiException;
//import de.uulm.omi.cloudiator.catalogue.client.api.DatabaseApi;


DatabaseApi apiInstance = new DatabaseApi();
String networType = "networType_example"; // String | specifies the network type for the dbms cluster
DatabaseCluster databaseComponents = new DatabaseCluster(); // DatabaseCluster | a set of database components
try {
    Deployment result = apiInstance.databaseClusterPost(networType, databaseComponents);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling DatabaseApi#databaseClusterPost");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **networType** | **String**| specifies the network type for the dbms cluster | [enum: PRIVATE, PUBLIC]
 **databaseComponents** | [**DatabaseCluster**](DatabaseCluster.md)| a set of database components |

### Return type

[**Deployment**](Deployment.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="databaseCrossClusterPost"></a>
# **databaseCrossClusterPost**
> Deployment databaseCrossClusterPost(networType, databaseComponents)

DDBMS cluster deployment

Deploy a database cluster in the multi-cloud 

### Example
```java
// Import classes:
//import de.uulm.omi.cloudiator.catalogue.client.ApiException;
//import de.uulm.omi.cloudiator.catalogue.client.api.DatabaseApi;


DatabaseApi apiInstance = new DatabaseApi();
String networType = "networType_example"; // String | specifies the network type for the dbms cluster
DatabaseCrossCluster databaseComponents = new DatabaseCrossCluster(); // DatabaseCrossCluster | a set of database components
try {
    Deployment result = apiInstance.databaseCrossClusterPost(networType, databaseComponents);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling DatabaseApi#databaseCrossClusterPost");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **networType** | **String**| specifies the network type for the dbms cluster | [enum: PRIVATE, PUBLIC]
 **databaseComponents** | [**DatabaseCrossCluster**](DatabaseCrossCluster.md)| a set of database components |

### Return type

[**Deployment**](Deployment.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="databaseSinglePost"></a>
# **databaseSinglePost**
> Deployment databaseSinglePost(networkType, databaseComponents)

DDBMS cluster deployment

Deploy a single DBMS node in the cloud, only for testing purposes. For integrating the | Application Catalogue the /database/cluster should be used 

### Example
```java
// Import classes:
//import de.uulm.omi.cloudiator.catalogue.client.ApiException;
//import de.uulm.omi.cloudiator.catalogue.client.api.DatabaseApi;


DatabaseApi apiInstance = new DatabaseApi();
String networkType = "networkType_example"; // String | specifies the network type for the dbms cluster
DatabaseSingle databaseComponents = new DatabaseSingle(); // DatabaseSingle | a set of database components
try {
    Deployment result = apiInstance.databaseSinglePost(networkType, databaseComponents);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling DatabaseApi#databaseSinglePost");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **networkType** | **String**| specifies the network type for the dbms cluster | [enum: PRIVATE, PUBLIC]
 **databaseComponents** | [**DatabaseSingle**](DatabaseSingle.md)| a set of database components |

### Return type

[**Deployment**](Deployment.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

