# UtilsApi

All URIs are relative to *http://localhost/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**utilsDeploymentStateGet**](UtilsApi.md#utilsDeploymentStateGet) | **GET** /utils/deploymentState | Get the state of a specific deployment


<a name="utilsDeploymentStateGet"></a>
# **utilsDeploymentStateGet**
> Deployment utilsDeploymentStateGet(applicationInstanceId)

Get the state of a specific deployment

### Example
```java
// Import classes:
//import de.uulm.omi.cloudiator.catalogue.client.ApiException;
//import de.uulm.omi.cloudiator.catalogue.client.api.UtilsApi;


UtilsApi apiInstance = new UtilsApi();
BigDecimal applicationInstanceId = new BigDecimal(); // BigDecimal | cloud data required to enable it in cloudiator
try {
    Deployment result = apiInstance.utilsDeploymentStateGet(applicationInstanceId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling UtilsApi#utilsDeploymentStateGet");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **applicationInstanceId** | **BigDecimal**| cloud data required to enable it in cloudiator |

### Return type

[**Deployment**](Deployment.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

