/*
 * Cloudiator Application Catalogue API
 * Deploy a generic distributed application in the cloud
 *
 * OpenAPI spec version: 0.0.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package de.uulm.omi.cloudiator.catalogue.client.api;

import de.uulm.omi.cloudiator.catalogue.client.ApiCallback;
import de.uulm.omi.cloudiator.catalogue.client.ApiClient;
import de.uulm.omi.cloudiator.catalogue.client.ApiException;
import de.uulm.omi.cloudiator.catalogue.client.ApiResponse;
import de.uulm.omi.cloudiator.catalogue.client.Configuration;
import de.uulm.omi.cloudiator.catalogue.client.Pair;
import de.uulm.omi.cloudiator.catalogue.client.ProgressRequestBody;
import de.uulm.omi.cloudiator.catalogue.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import de.uulm.omi.cloudiator.dbms.evaluator.model.Component;
import de.uulm.omi.cloudiator.dbms.evaluator.model.Deployment;
import de.uulm.omi.cloudiator.dbms.evaluator.model.Error;

import java.lang.reflect.Type;

public class ApplicationApi {
    private ApiClient apiClient;

    public ApplicationApi() {
        this(Configuration.getDefaultApiClient());
    }

    public ApplicationApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for genericPost
     * @param applicationName maps to the parent application description to identify its application components (required)
     * @param networkType specifies the network type for the generic application (required)
     * @param components a list of application components (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call genericPostCall(String applicationName, String networkType, java.util.List<Component> components, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = components;

        // create path and map variables
        String localVarPath = "/generic";

        java.util.List<Pair> localVarQueryParams = new java.util.ArrayList<Pair>();
        java.util.List<Pair> localVarCollectionQueryParams = new java.util.ArrayList<Pair>();
        if (applicationName != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("applicationName", applicationName));
        if (networkType != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("networkType", networkType));

        java.util.Map<String, String> localVarHeaderParams = new java.util.HashMap<String, String>();

        java.util.Map<String, Object> localVarFormParams = new java.util.HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call genericPostValidateBeforeCall(String applicationName, String networkType, java.util.List<Component> components, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'applicationName' is set
        if (applicationName == null) {
            throw new ApiException("Missing the required parameter 'applicationName' when calling genericPost(Async)");
        }
        
        // verify the required parameter 'networkType' is set
        if (networkType == null) {
            throw new ApiException("Missing the required parameter 'networkType' when calling genericPost(Async)");
        }
        
        // verify the required parameter 'components' is set
        if (components == null) {
            throw new ApiException("Missing the required parameter 'components' when calling genericPost(Async)");
        }
        

        com.squareup.okhttp.Call call = genericPostCall(applicationName, networkType, components, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Generic application deployment
     * Deploy a generic application in a multi-cloud setup 
     * @param applicationName maps to the parent application description to identify its application components (required)
     * @param networkType specifies the network type for the generic application (required)
     * @param components a list of application components (required)
     * @return Deployment
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Deployment genericPost(String applicationName, String networkType, java.util.List<Component> components) throws ApiException {
        ApiResponse<Deployment> resp = genericPostWithHttpInfo(applicationName, networkType, components);
        return resp.getData();
    }

    /**
     * Generic application deployment
     * Deploy a generic application in a multi-cloud setup 
     * @param applicationName maps to the parent application description to identify its application components (required)
     * @param networkType specifies the network type for the generic application (required)
     * @param components a list of application components (required)
     * @return ApiResponse&lt;Deployment&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Deployment> genericPostWithHttpInfo(String applicationName, String networkType, java.util.List<Component> components) throws ApiException {
        com.squareup.okhttp.Call call = genericPostValidateBeforeCall(applicationName, networkType, components, null, null);
        Type localVarReturnType = new TypeToken<Deployment>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Generic application deployment (asynchronously)
     * Deploy a generic application in a multi-cloud setup 
     * @param applicationName maps to the parent application description to identify its application components (required)
     * @param networkType specifies the network type for the generic application (required)
     * @param components a list of application components (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call genericPostAsync(String applicationName, String networkType, java.util.List<Component> components, final ApiCallback<Deployment> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = genericPostValidateBeforeCall(applicationName, networkType, components, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<Deployment>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
