/*
 * Cloudiator Application Catalogue API
 * Deploy a generic distributed application in the cloud
 *
 * OpenAPI spec version: 0.0.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package de.uulm.omi.cloudiator.catalogue.client.api;

import de.uulm.omi.cloudiator.catalogue.client.ApiCallback;
import de.uulm.omi.cloudiator.catalogue.client.ApiClient;
import de.uulm.omi.cloudiator.catalogue.client.ApiException;
import de.uulm.omi.cloudiator.catalogue.client.ApiResponse;
import de.uulm.omi.cloudiator.catalogue.client.Configuration;
import de.uulm.omi.cloudiator.catalogue.client.Pair;
import de.uulm.omi.cloudiator.catalogue.client.ProgressRequestBody;
import de.uulm.omi.cloudiator.catalogue.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import de.uulm.omi.cloudiator.dbms.evaluator.model.Cluster;
import de.uulm.omi.cloudiator.dbms.evaluator.model.Deployment;
import de.uulm.omi.cloudiator.dbms.evaluator.model.Error;
import de.uulm.omi.cloudiator.dbms.evaluator.model.SparkJob;

import java.lang.reflect.Type;

public class BigDataApi {
    private ApiClient apiClient;

    public BigDataApi() {
        this(Configuration.getDefaultApiClient());
    }

    public BigDataApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for bigdataSparkPost
     * @param name the application  name, needs to map an existing application description (required)
     * @param cluster the Spark cluster, including one master and n workers (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call bigdataSparkPostCall(String name, Cluster cluster, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = cluster;

        // create path and map variables
        String localVarPath = "/bigdata/spark";

        java.util.List<Pair> localVarQueryParams = new java.util.ArrayList<Pair>();
        java.util.List<Pair> localVarCollectionQueryParams = new java.util.ArrayList<Pair>();
        if (name != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("name", name));

        java.util.Map<String, String> localVarHeaderParams = new java.util.HashMap<String, String>();

        java.util.Map<String, Object> localVarFormParams = new java.util.HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call bigdataSparkPostValidateBeforeCall(String name, Cluster cluster, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'name' is set
        if (name == null) {
            throw new ApiException("Missing the required parameter 'name' when calling bigdataSparkPost(Async)");
        }
        
        // verify the required parameter 'cluster' is set
        if (cluster == null) {
            throw new ApiException("Missing the required parameter 'cluster' when calling bigdataSparkPost(Async)");
        }
        

        com.squareup.okhttp.Call call = bigdataSparkPostCall(name, cluster, progressListener, progressRequestListener);
        return call;

    }

    /**
     * deploys an Apache Spark cluster
     * Deploys a Spark cluster with 1 master and n workers in a multi-cloud environment or a Knime Spark cluster with a job server in front of the Master 
     * @param name the application  name, needs to map an existing application description (required)
     * @param cluster the Spark cluster, including one master and n workers (required)
     * @return Deployment
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Deployment bigdataSparkPost(String name, Cluster cluster) throws ApiException {
        ApiResponse<Deployment> resp = bigdataSparkPostWithHttpInfo(name, cluster);
        return resp.getData();
    }

    /**
     * deploys an Apache Spark cluster
     * Deploys a Spark cluster with 1 master and n workers in a multi-cloud environment or a Knime Spark cluster with a job server in front of the Master 
     * @param name the application  name, needs to map an existing application description (required)
     * @param cluster the Spark cluster, including one master and n workers (required)
     * @return ApiResponse&lt;Deployment&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Deployment> bigdataSparkPostWithHttpInfo(String name, Cluster cluster) throws ApiException {
        com.squareup.okhttp.Call call = bigdataSparkPostValidateBeforeCall(name, cluster, null, null);
        Type localVarReturnType = new TypeToken<Deployment>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * deploys an Apache Spark cluster (asynchronously)
     * Deploys a Spark cluster with 1 master and n workers in a multi-cloud environment or a Knime Spark cluster with a job server in front of the Master 
     * @param name the application  name, needs to map an existing application description (required)
     * @param cluster the Spark cluster, including one master and n workers (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call bigdataSparkPostAsync(String name, Cluster cluster, final ApiCallback<Deployment> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = bigdataSparkPostValidateBeforeCall(name, cluster, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<Deployment>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for bigdataSparkSparkJobPost
     * @param job the Spark job to submit (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call bigdataSparkSparkJobPostCall(SparkJob job, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = job;

        // create path and map variables
        String localVarPath = "/bigdata/spark/sparkJob";

        java.util.List<Pair> localVarQueryParams = new java.util.ArrayList<Pair>();
        java.util.List<Pair> localVarCollectionQueryParams = new java.util.ArrayList<Pair>();

        java.util.Map<String, String> localVarHeaderParams = new java.util.HashMap<String, String>();

        java.util.Map<String, Object> localVarFormParams = new java.util.HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call bigdataSparkSparkJobPostValidateBeforeCall(SparkJob job, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'job' is set
        if (job == null) {
            throw new ApiException("Missing the required parameter 'job' when calling bigdataSparkSparkJobPost(Async)");
        }
        

        com.squareup.okhttp.Call call = bigdataSparkSparkJobPostCall(job, progressListener, progressRequestListener);
        return call;

    }

    /**
     * submit an Apache Spark job to a Spark Master
     * Submitting Spark jobs to an existing Apache Spark Cluster  
     * @param job the Spark job to submit (required)
     * @return java.util.List&lt;Deployment&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public java.util.List<Deployment> bigdataSparkSparkJobPost(SparkJob job) throws ApiException {
        ApiResponse<java.util.List<Deployment>> resp = bigdataSparkSparkJobPostWithHttpInfo(job);
        return resp.getData();
    }

    /**
     * submit an Apache Spark job to a Spark Master
     * Submitting Spark jobs to an existing Apache Spark Cluster  
     * @param job the Spark job to submit (required)
     * @return ApiResponse&lt;java.util.List&lt;Deployment&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<java.util.List<Deployment>> bigdataSparkSparkJobPostWithHttpInfo(SparkJob job) throws ApiException {
        com.squareup.okhttp.Call call = bigdataSparkSparkJobPostValidateBeforeCall(job, null, null);
        Type localVarReturnType = new TypeToken<java.util.List<Deployment>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * submit an Apache Spark job to a Spark Master (asynchronously)
     * Submitting Spark jobs to an existing Apache Spark Cluster  
     * @param job the Spark job to submit (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call bigdataSparkSparkJobPostAsync(SparkJob job, final ApiCallback<java.util.List<Deployment>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = bigdataSparkSparkJobPostValidateBeforeCall(job, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<java.util.List<Deployment>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
