/*
 * Cloudiator Application Catalogue API
 * Deploy a generic distributed application in the cloud
 *
 * OpenAPI spec version: 0.0.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package de.uulm.omi.cloudiator.catalogue.client.api;

import de.uulm.omi.cloudiator.catalogue.client.ApiCallback;
import de.uulm.omi.cloudiator.catalogue.client.ApiClient;
import de.uulm.omi.cloudiator.catalogue.client.ApiException;
import de.uulm.omi.cloudiator.catalogue.client.ApiResponse;
import de.uulm.omi.cloudiator.catalogue.client.Configuration;
import de.uulm.omi.cloudiator.catalogue.client.Pair;
import de.uulm.omi.cloudiator.catalogue.client.ProgressRequestBody;
import de.uulm.omi.cloudiator.catalogue.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import de.uulm.omi.cloudiator.dbms.evaluator.model.DatabaseCluster;
import de.uulm.omi.cloudiator.dbms.evaluator.model.DatabaseCrossCluster;
import de.uulm.omi.cloudiator.dbms.evaluator.model.DatabaseSingle;
import de.uulm.omi.cloudiator.dbms.evaluator.model.Deployment;
import de.uulm.omi.cloudiator.dbms.evaluator.model.Error;

import java.lang.reflect.Type;

public class DatabaseApi {
    private ApiClient apiClient;

    public DatabaseApi() {
        this(Configuration.getDefaultApiClient());
    }

    public DatabaseApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for databaseClusterPost
     * @param networType specifies the network type for the dbms cluster (required)
     * @param databaseComponents a set of database components (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call databaseClusterPostCall(String networType, DatabaseCluster databaseComponents, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = databaseComponents;

        // create path and map variables
        String localVarPath = "/database/cluster";

        java.util.List<Pair> localVarQueryParams = new java.util.ArrayList<Pair>();
        java.util.List<Pair> localVarCollectionQueryParams = new java.util.ArrayList<Pair>();
        if (networType != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("networType", networType));

        java.util.Map<String, String> localVarHeaderParams = new java.util.HashMap<String, String>();

        java.util.Map<String, Object> localVarFormParams = new java.util.HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call databaseClusterPostValidateBeforeCall(String networType, DatabaseCluster databaseComponents, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'networType' is set
        if (networType == null) {
            throw new ApiException("Missing the required parameter 'networType' when calling databaseClusterPost(Async)");
        }
        
        // verify the required parameter 'databaseComponents' is set
        if (databaseComponents == null) {
            throw new ApiException("Missing the required parameter 'databaseComponents' when calling databaseClusterPost(Async)");
        }
        

        com.squareup.okhttp.Call call = databaseClusterPostCall(networType, databaseComponents, progressListener, progressRequestListener);
        return call;

    }

    /**
     * DDBMS cluster deployment
     * Deploy a database cluster in the multi-cloud 
     * @param networType specifies the network type for the dbms cluster (required)
     * @param databaseComponents a set of database components (required)
     * @return Deployment
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Deployment databaseClusterPost(String networType, DatabaseCluster databaseComponents) throws ApiException {
        ApiResponse<Deployment> resp = databaseClusterPostWithHttpInfo(networType, databaseComponents);
        return resp.getData();
    }

    /**
     * DDBMS cluster deployment
     * Deploy a database cluster in the multi-cloud 
     * @param networType specifies the network type for the dbms cluster (required)
     * @param databaseComponents a set of database components (required)
     * @return ApiResponse&lt;Deployment&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Deployment> databaseClusterPostWithHttpInfo(String networType, DatabaseCluster databaseComponents) throws ApiException {
        com.squareup.okhttp.Call call = databaseClusterPostValidateBeforeCall(networType, databaseComponents, null, null);
        Type localVarReturnType = new TypeToken<Deployment>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * DDBMS cluster deployment (asynchronously)
     * Deploy a database cluster in the multi-cloud 
     * @param networType specifies the network type for the dbms cluster (required)
     * @param databaseComponents a set of database components (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call databaseClusterPostAsync(String networType, DatabaseCluster databaseComponents, final ApiCallback<Deployment> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = databaseClusterPostValidateBeforeCall(networType, databaseComponents, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<Deployment>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for databaseCrossClusterPost
     * @param networType specifies the network type for the dbms cluster (required)
     * @param databaseComponents a set of database components (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call databaseCrossClusterPostCall(String networType, DatabaseCrossCluster databaseComponents, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = databaseComponents;

        // create path and map variables
        String localVarPath = "/database/crossCluster";

        java.util.List<Pair> localVarQueryParams = new java.util.ArrayList<Pair>();
        java.util.List<Pair> localVarCollectionQueryParams = new java.util.ArrayList<Pair>();
        if (networType != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("networType", networType));

        java.util.Map<String, String> localVarHeaderParams = new java.util.HashMap<String, String>();

        java.util.Map<String, Object> localVarFormParams = new java.util.HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call databaseCrossClusterPostValidateBeforeCall(String networType, DatabaseCrossCluster databaseComponents, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'networType' is set
        if (networType == null) {
            throw new ApiException("Missing the required parameter 'networType' when calling databaseCrossClusterPost(Async)");
        }
        
        // verify the required parameter 'databaseComponents' is set
        if (databaseComponents == null) {
            throw new ApiException("Missing the required parameter 'databaseComponents' when calling databaseCrossClusterPost(Async)");
        }
        

        com.squareup.okhttp.Call call = databaseCrossClusterPostCall(networType, databaseComponents, progressListener, progressRequestListener);
        return call;

    }

    /**
     * DDBMS cluster deployment
     * Deploy a database cluster in the multi-cloud 
     * @param networType specifies the network type for the dbms cluster (required)
     * @param databaseComponents a set of database components (required)
     * @return Deployment
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Deployment databaseCrossClusterPost(String networType, DatabaseCrossCluster databaseComponents) throws ApiException {
        ApiResponse<Deployment> resp = databaseCrossClusterPostWithHttpInfo(networType, databaseComponents);
        return resp.getData();
    }

    /**
     * DDBMS cluster deployment
     * Deploy a database cluster in the multi-cloud 
     * @param networType specifies the network type for the dbms cluster (required)
     * @param databaseComponents a set of database components (required)
     * @return ApiResponse&lt;Deployment&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Deployment> databaseCrossClusterPostWithHttpInfo(String networType, DatabaseCrossCluster databaseComponents) throws ApiException {
        com.squareup.okhttp.Call call = databaseCrossClusterPostValidateBeforeCall(networType, databaseComponents, null, null);
        Type localVarReturnType = new TypeToken<Deployment>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * DDBMS cluster deployment (asynchronously)
     * Deploy a database cluster in the multi-cloud 
     * @param networType specifies the network type for the dbms cluster (required)
     * @param databaseComponents a set of database components (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call databaseCrossClusterPostAsync(String networType, DatabaseCrossCluster databaseComponents, final ApiCallback<Deployment> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = databaseCrossClusterPostValidateBeforeCall(networType, databaseComponents, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<Deployment>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for databaseSinglePost
     * @param networkType specifies the network type for the dbms cluster (required)
     * @param databaseComponents a set of database components (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call databaseSinglePostCall(String networkType, DatabaseSingle databaseComponents, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = databaseComponents;

        // create path and map variables
        String localVarPath = "/database/single";

        java.util.List<Pair> localVarQueryParams = new java.util.ArrayList<Pair>();
        java.util.List<Pair> localVarCollectionQueryParams = new java.util.ArrayList<Pair>();
        if (networkType != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("networkType", networkType));

        java.util.Map<String, String> localVarHeaderParams = new java.util.HashMap<String, String>();

        java.util.Map<String, Object> localVarFormParams = new java.util.HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call databaseSinglePostValidateBeforeCall(String networkType, DatabaseSingle databaseComponents, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'networkType' is set
        if (networkType == null) {
            throw new ApiException("Missing the required parameter 'networkType' when calling databaseSinglePost(Async)");
        }
        
        // verify the required parameter 'databaseComponents' is set
        if (databaseComponents == null) {
            throw new ApiException("Missing the required parameter 'databaseComponents' when calling databaseSinglePost(Async)");
        }
        

        com.squareup.okhttp.Call call = databaseSinglePostCall(networkType, databaseComponents, progressListener, progressRequestListener);
        return call;

    }

    /**
     * DDBMS cluster deployment
     * Deploy a single DBMS node in the cloud, only for testing purposes. For integrating the | Application Catalogue the /database/cluster should be used 
     * @param networkType specifies the network type for the dbms cluster (required)
     * @param databaseComponents a set of database components (required)
     * @return Deployment
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Deployment databaseSinglePost(String networkType, DatabaseSingle databaseComponents) throws ApiException {
        ApiResponse<Deployment> resp = databaseSinglePostWithHttpInfo(networkType, databaseComponents);
        return resp.getData();
    }

    /**
     * DDBMS cluster deployment
     * Deploy a single DBMS node in the cloud, only for testing purposes. For integrating the | Application Catalogue the /database/cluster should be used 
     * @param networkType specifies the network type for the dbms cluster (required)
     * @param databaseComponents a set of database components (required)
     * @return ApiResponse&lt;Deployment&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Deployment> databaseSinglePostWithHttpInfo(String networkType, DatabaseSingle databaseComponents) throws ApiException {
        com.squareup.okhttp.Call call = databaseSinglePostValidateBeforeCall(networkType, databaseComponents, null, null);
        Type localVarReturnType = new TypeToken<Deployment>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * DDBMS cluster deployment (asynchronously)
     * Deploy a single DBMS node in the cloud, only for testing purposes. For integrating the | Application Catalogue the /database/cluster should be used 
     * @param networkType specifies the network type for the dbms cluster (required)
     * @param databaseComponents a set of database components (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call databaseSinglePostAsync(String networkType, DatabaseSingle databaseComponents, final ApiCallback<Deployment> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = databaseSinglePostValidateBeforeCall(networkType, databaseComponents, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<Deployment>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
