/*
 * Cloudiator Application Catalogue API
 * Deploy a generic distributed application in the cloud
 *
 * OpenAPI spec version: 0.0.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package de.uulm.omi.cloudiator.catalogue.client.api;

import de.uulm.omi.cloudiator.catalogue.client.ApiCallback;
import de.uulm.omi.cloudiator.catalogue.client.ApiClient;
import de.uulm.omi.cloudiator.catalogue.client.ApiException;
import de.uulm.omi.cloudiator.catalogue.client.ApiResponse;
import de.uulm.omi.cloudiator.catalogue.client.Configuration;
import de.uulm.omi.cloudiator.catalogue.client.Pair;
import de.uulm.omi.cloudiator.catalogue.client.ProgressRequestBody;
import de.uulm.omi.cloudiator.catalogue.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import java.math.BigDecimal;
import de.uulm.omi.cloudiator.dbms.evaluator.model.Deployment;
import de.uulm.omi.cloudiator.dbms.evaluator.model.Error;

import java.lang.reflect.Type;

public class UtilsApi {
    private ApiClient apiClient;

    public UtilsApi() {
        this(Configuration.getDefaultApiClient());
    }

    public UtilsApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for utilsDeploymentStateGet
     * @param applicationInstanceId cloud data required to enable it in cloudiator (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call utilsDeploymentStateGetCall(BigDecimal applicationInstanceId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/utils/deploymentState";

        java.util.List<Pair> localVarQueryParams = new java.util.ArrayList<Pair>();
        java.util.List<Pair> localVarCollectionQueryParams = new java.util.ArrayList<Pair>();
        if (applicationInstanceId != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("applicationInstanceId", applicationInstanceId));

        java.util.Map<String, String> localVarHeaderParams = new java.util.HashMap<String, String>();

        java.util.Map<String, Object> localVarFormParams = new java.util.HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call utilsDeploymentStateGetValidateBeforeCall(BigDecimal applicationInstanceId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'applicationInstanceId' is set
        if (applicationInstanceId == null) {
            throw new ApiException("Missing the required parameter 'applicationInstanceId' when calling utilsDeploymentStateGet(Async)");
        }
        

        com.squareup.okhttp.Call call = utilsDeploymentStateGetCall(applicationInstanceId, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Get the state of a specific deployment
     * 
     * @param applicationInstanceId cloud data required to enable it in cloudiator (required)
     * @return Deployment
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Deployment utilsDeploymentStateGet(BigDecimal applicationInstanceId) throws ApiException {
        ApiResponse<Deployment> resp = utilsDeploymentStateGetWithHttpInfo(applicationInstanceId);
        return resp.getData();
    }

    /**
     * Get the state of a specific deployment
     * 
     * @param applicationInstanceId cloud data required to enable it in cloudiator (required)
     * @return ApiResponse&lt;Deployment&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Deployment> utilsDeploymentStateGetWithHttpInfo(BigDecimal applicationInstanceId) throws ApiException {
        com.squareup.okhttp.Call call = utilsDeploymentStateGetValidateBeforeCall(applicationInstanceId, null, null);
        Type localVarReturnType = new TypeToken<Deployment>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get the state of a specific deployment (asynchronously)
     * 
     * @param applicationInstanceId cloud data required to enable it in cloudiator (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call utilsDeploymentStateGetAsync(BigDecimal applicationInstanceId, final ApiCallback<Deployment> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = utilsDeploymentStateGetValidateBeforeCall(applicationInstanceId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<Deployment>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
