/*
 * Cloudiator Application Catalogue API
 * Deploy a generic distributed application in the cloud
 *
 * OpenAPI spec version: 0.0.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package de.uulm.omi.cloudiator.dbms.evaluator.model;

import java.util.Objects;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import de.uulm.omi.cloudiator.dbms.evaluator.model.Component;
import de.uulm.omi.cloudiator.dbms.evaluator.model.CustomConfiguration;
import de.uulm.omi.cloudiator.dbms.evaluator.model.NodeConfiguration;
import de.uulm.omi.cloudiator.dbms.evaluator.model.ReplicationFactor;
import de.uulm.omi.cloudiator.dbms.evaluator.model.VM;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * A seed component of a DDBMS, provides the cluster entrypoint for DatabaseDataComponents
 */
@ApiModel(description = "A seed component of a DDBMS, provides the cluster entrypoint for DatabaseDataComponents")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2019-02-22T13:01:31.778Z")
public class DatabaseSeedComponent {
  @SerializedName("instances")
  private Integer instances = null;

  @SerializedName("resource")
  private VM resource = null;

  @SerializedName("customConfiguration")
  private CustomConfiguration customConfiguration = null;

  /**
   * Gets or Sets name
   */
  @JsonAdapter(NameEnum.Adapter.class)
  public enum NameEnum {
    SEED("SEED");

    private String value;

    NameEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static NameEnum fromValue(String text) {
      for (NameEnum b : NameEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }

    public static class Adapter extends TypeAdapter<NameEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final NameEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public NameEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return NameEnum.fromValue(String.valueOf(value));
      }
    }
  }

  @SerializedName("name")
  private NameEnum name = null;

  @SerializedName("replicationFactor")
  private ReplicationFactor replicationFactor = null;

  @SerializedName("nodeConfiguration")
  private NodeConfiguration nodeConfiguration = null;

  public DatabaseSeedComponent instances(Integer instances) {
    this.instances = instances;
    return this;
  }

   /**
   * number of component instances
   * @return instances
  **/
  @ApiModelProperty(value = "number of component instances")
  public Integer getInstances() {
    return instances;
  }

  public void setInstances(Integer instances) {
    this.instances = instances;
  }

  public DatabaseSeedComponent resource(VM resource) {
    this.resource = resource;
    return this;
  }

   /**
   * Get resource
   * @return resource
  **/
  @ApiModelProperty(value = "")
  public VM getResource() {
    return resource;
  }

  public void setResource(VM resource) {
    this.resource = resource;
  }

  public DatabaseSeedComponent customConfiguration(CustomConfiguration customConfiguration) {
    this.customConfiguration = customConfiguration;
    return this;
  }

   /**
   * Get customConfiguration
   * @return customConfiguration
  **/
  @ApiModelProperty(value = "")
  public CustomConfiguration getCustomConfiguration() {
    return customConfiguration;
  }

  public void setCustomConfiguration(CustomConfiguration customConfiguration) {
    this.customConfiguration = customConfiguration;
  }

  public DatabaseSeedComponent name(NameEnum name) {
    this.name = name;
    return this;
  }

   /**
   * Get name
   * @return name
  **/
  @ApiModelProperty(value = "")
  public NameEnum getName() {
    return name;
  }

  public void setName(NameEnum name) {
    this.name = name;
  }

  public DatabaseSeedComponent replicationFactor(ReplicationFactor replicationFactor) {
    this.replicationFactor = replicationFactor;
    return this;
  }

   /**
   * Get replicationFactor
   * @return replicationFactor
  **/
  @ApiModelProperty(value = "")
  public ReplicationFactor getReplicationFactor() {
    return replicationFactor;
  }

  public void setReplicationFactor(ReplicationFactor replicationFactor) {
    this.replicationFactor = replicationFactor;
  }

  public DatabaseSeedComponent nodeConfiguration(NodeConfiguration nodeConfiguration) {
    this.nodeConfiguration = nodeConfiguration;
    return this;
  }

   /**
   * Get nodeConfiguration
   * @return nodeConfiguration
  **/
  @ApiModelProperty(value = "")
  public NodeConfiguration getNodeConfiguration() {
    return nodeConfiguration;
  }

  public void setNodeConfiguration(NodeConfiguration nodeConfiguration) {
    this.nodeConfiguration = nodeConfiguration;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    DatabaseSeedComponent databaseSeedComponent = (DatabaseSeedComponent) o;
    return Objects.equals(this.instances, databaseSeedComponent.instances) &&
        Objects.equals(this.resource, databaseSeedComponent.resource) &&
        Objects.equals(this.customConfiguration, databaseSeedComponent.customConfiguration) &&
        Objects.equals(this.name, databaseSeedComponent.name) &&
        Objects.equals(this.replicationFactor, databaseSeedComponent.replicationFactor) &&
        Objects.equals(this.nodeConfiguration, databaseSeedComponent.nodeConfiguration);
  }

  @Override
  public int hashCode() {
    return Objects.hash(instances, resource, customConfiguration, name, replicationFactor, nodeConfiguration);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class DatabaseSeedComponent {\n");
    
    sb.append("    instances: ").append(toIndentedString(instances)).append("\n");
    sb.append("    resource: ").append(toIndentedString(resource)).append("\n");
    sb.append("    customConfiguration: ").append(toIndentedString(customConfiguration)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    replicationFactor: ").append(toIndentedString(replicationFactor)).append("\n");
    sb.append("    nodeConfiguration: ").append(toIndentedString(nodeConfiguration)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

